#!/bin/bash

echo "Used machine is $(uname -a)"
echo "Selected GPU is _CONDOR_Assignedgpus = '${_CONDOR_Assignedgpus}'"

BUILD_DIR="build_$(uname -n)"

if [ -d $BUILD_DIR ]
then
    	echo "Remove existing directory $BUILD_DIR"
        rm -fr $BUILD_DIR
fi

mkdir -p $BUILD_DIR
cd $BUILD_DIR

EXTRA_OPTION=""
if [ ! -z ${_CONDOR_Assignedgpus} ]
then
	EXTRA_OPTION="-DSELECTED_GPU=${_CONDOR_Assignedgpus}"
fi

cmake3 .. -DCMAKE_CXX_COMPILER=/opt/rh/devtoolset-11/root/usr/bin/x86_64-redhat-linux-g++ -DCMAKE_C_COMPILER=/opt/rh/devtoolset-11/root/usr/bin/x86_64-redhat-linux-gcc -DMUST_JOB=yes ${EXTRA_OPTION}
make

NB_TEST_PER_PROGRAM=10

>&2 echo "======== Gray Scott GPU Cuda ========"
for i in `seq 1 ${NB_TEST_PER_PROGRAM}`
do
	echo "Gray Scott GPU Cuda $i"
	time ./program/gray_scott_gpu_cuda -n 1000 -r 1080 -c 1920 -e 34
done

>&2 echo "======== Gray Scott GPU Cuda no temporary ========"
for i in `seq 1 ${NB_TEST_PER_PROGRAM}`
do
	echo "Gray Scott GPU Cuda no temporary $i"
	time ./program/gray_scott_gpu_cuda_stupid -n 1000 -r 1080 -c 1920 -e 34
done
